--- old/usr/src/cmd/cmd-inet/sbin/dhcpagent/Makefile	Sun Aug  5 23:40:55 2018
+++ new/usr/src/cmd/cmd-inet/sbin/dhcpagent/Makefile	Sun Aug  5 23:40:55 2018
@@ -47,7 +47,7 @@
 
 CPPFLAGS  += -D_XOPEN_SOURCE=500 -D__EXTENSIONS__
 LDLIBS    += -lxnet -lnvpair -ldhcpagent -ldhcputil -linetutil -ldevinfo \
-	-ldlpi -lresolv -lsocket -lipadm
+	-ldlpi -lresolv -lipadm
 
 # Disable warnings that affect all XPG applications.
 LINTFLAGS += -erroff=E_INCONS_ARG_DECL2 -erroff=E_INCONS_VAL_TYPE_DECL2
--- old/usr/src/cmd/hal/addons/network-devices/Makefile	Sun Aug  5 23:40:55 2018
+++ new/usr/src/cmd/hal/addons/network-devices/Makefile	Sun Aug  5 23:40:55 2018
@@ -39,8 +39,7 @@
 
 ROOTCMDDIR =	$(ROOTLIB_HAL)
 
-LDLIBS +=	-lc -ldbus-1 -lhal -lglib-2.0 -ldbus-glib-1
-LDLIBS +=	-lnsl -lsocket
+LDLIBS +=	-lc -ldbus-1 -lhal -lglib-2.0 -ldbus-glib-1 -lnsl
 LDLIBS +=	$(ZIGNORE) -lnetsnmp
 
 CPPFLAGS +=	$(HAL_DBUS_CPPFLAGS) $(HAL_GLIB_CPPFLAGS) $(HAL_CONFIG_CPPFLAGS)
--- old/usr/src/cmd/print/bsd-sysv-commands/Makefile	Sun Aug  5 23:40:55 2018
+++ new/usr/src/cmd/print/bsd-sysv-commands/Makefile	Sun Aug  5 23:40:55 2018
@@ -62,7 +62,7 @@
 CPPFLAGS +=	-I../../lp/include
 LDLIBS +=	$(LIBLP) -lpapi -lc
 in.lpd:=	CFLAGS +=	-DSOLARIS_PRIVATE_POST_0_9
-in.lpd:=	LDLIBS +=	-lnsl -lsocket
+in.lpd:=	LDLIBS +=	-lnsl
 
 CERRWARN +=	-_gcc=-Wno-unused-variable
 CERRWARN +=	-_gcc=-Wno-uninitialized
--- old/usr/src/lib/krb5/kadm5/clnt/amd64/Makefile	Sun Aug  5 23:40:56 2018
+++ new/usr/src/lib/krb5/kadm5/clnt/amd64/Makefile	Sun Aug  5 23:40:56 2018
@@ -22,13 +22,11 @@
 # Copyright 2006 Sun Microsystems, Inc.  All rights reserved.
 # Use is subject to license terms.
 #
-# ident	"%Z%%M%	%I%	%E% SMI"
-#
 
 include ../Makefile.com
 include ../../../../Makefile.lib.64
 
 DYNFLAGS += $(KRUNPATH64) $(KMECHLIB64)
-LDLIBS += -L $(ROOTLIBDIR) -lgss -lnsl -lsocket -lc
+LDLIBS += -L $(ROOTLIBDIR) -lgss -lnsl -lc
 
 install: all $(ROOTLIBS64) $(ROOTLINKS64)
--- old/usr/src/lib/krb5/kadm5/clnt/i386/Makefile	Sun Aug  5 23:40:56 2018
+++ new/usr/src/lib/krb5/kadm5/clnt/i386/Makefile	Sun Aug  5 23:40:56 2018
@@ -22,12 +22,10 @@
 # Copyright 2006 Sun Microsystems, Inc.  All rights reserved.
 # Use is subject to license terms.
 #
-# ident	"%Z%%M%	%I%	%E% SMI"
-#
 
 include ../Makefile.com
 
 DYNFLAGS += $(KRUNPATH) $(KMECHLIB)
-LDLIBS += -L $(ROOTLIBDIR) -lgss -lnsl -lsocket -lc
- 
+LDLIBS += -L $(ROOTLIBDIR) -lgss -lnsl -lc
+
 install: all $(ROOTLIBS) $(ROOTLINKS)
--- old/usr/src/lib/krb5/kadm5/clnt/sparc/Makefile	Sun Aug  5 23:40:56 2018
+++ new/usr/src/lib/krb5/kadm5/clnt/sparc/Makefile	Sun Aug  5 23:40:56 2018
@@ -22,12 +22,10 @@
 # Copyright 2006 Sun Microsystems, Inc.  All rights reserved.
 # Use is subject to license terms.
 #
-# ident	"%Z%%M%	%I%	%E% SMI"
-#
 
 include ../Makefile.com
 
 DYNFLAGS += $(KRUNPATH) $(KMECHLIB)
-LDLIBS += -L $(ROOTLIBDIR) -lgss -lnsl -lsocket -lc
+LDLIBS += -L $(ROOTLIBDIR) -lgss -lnsl -lc
 
 install: all $(ROOTLIBS) $(ROOTLINKS)
--- old/usr/src/lib/krb5/kadm5/clnt/sparcv9/Makefile	Sun Aug  5 23:40:56 2018
+++ new/usr/src/lib/krb5/kadm5/clnt/sparcv9/Makefile	Sun Aug  5 23:40:57 2018
@@ -22,13 +22,11 @@
 # Copyright 2006 Sun Microsystems, Inc.  All rights reserved.
 # Use is subject to license terms.
 #
-# ident	"%Z%%M%	%I%	%E% SMI"
-#
 
 include ../Makefile.com
 include ../../../../Makefile.lib.64
 
 DYNFLAGS += $(KRUNPATH64) $(KMECHLIB64)
-LDLIBS += -L $(ROOTLIBDIR) -lgss -lnsl -lsocket -lc
+LDLIBS += -L $(ROOTLIBDIR) -lgss -lnsl -lc
 
 install: all $(ROOTLIBS64) $(ROOTLINKS64)
--- old/usr/src/lib/krb5/kadm5/srv/i386/Makefile	Sun Aug  5 23:40:57 2018
+++ new/usr/src/lib/krb5/kadm5/srv/i386/Makefile	Sun Aug  5 23:40:57 2018
@@ -22,8 +22,6 @@
 # Copyright 2008 Sun Microsystems, Inc.  All rights reserved.
 # Use is subject to license terms.
 #
-# ident	"%Z%%M%	%I%	%E% SMI"
-#
 
 include ../Makefile.com
 
@@ -30,6 +28,6 @@
 # library dependency
 DYNFLAGS += $(KRUNPATH) $(KERBRUNPATH) $(KMECHLIB)
 DYNFLAGS += $(KRB5LIB)/libkdb.so $(KRB5LIB)/libdyn.so
-LDLIBS += -L $(ROOTLIBDIR) -lgss -lnsl -lc -lsocket
+LDLIBS += -L $(ROOTLIBDIR) -lgss -lnsl -lc
 
 install: all $(ROOTLIBS) $(ROOTLINKS)
--- old/usr/src/lib/krb5/kadm5/srv/sparc/Makefile	Sun Aug  5 23:40:57 2018
+++ new/usr/src/lib/krb5/kadm5/srv/sparc/Makefile	Sun Aug  5 23:40:57 2018
@@ -22,8 +22,6 @@
 # Copyright 2008 Sun Microsystems, Inc.  All rights reserved.
 # Use is subject to license terms.
 #
-# ident	"%Z%%M%	%I%	%E% SMI"
-#
 
 include ../Makefile.com
 
@@ -30,6 +28,6 @@
 # library dependency
 DYNFLAGS += $(KRUNPATH) $(KERBRUNPATH) $(KMECHLIB)
 DYNFLAGS += $(KRB5LIB)/libkdb.so $(KRB5LIB)/libdyn.so
-LDLIBS += -L $(ROOTLIBDIR) -lgss -lnsl -lc -lsocket
+LDLIBS += -L $(ROOTLIBDIR) -lgss -lnsl -lc
 
 install: all $(ROOTLIBS) $(ROOTLINKS)
--- old/usr/src/lib/libc/Makefile.targ	Sun Aug  5 23:40:57 2018
+++ new/usr/src/lib/libc/Makefile.targ	Sun Aug  5 23:40:57 2018
@@ -205,6 +205,11 @@
 	-I$(LIBCBASE)/../port/gen -o $@ $<
 	$(POST_PROCESS_O)
 
+# socket rules
+pics/%.o: $(LIBCBASE)/../port/socket/%.c
+	$(COMPILE.c) -o $@ $<
+	$(POST_PROCESS_O)
+
 # stdio rules
 pics/%.o: $(LIBCBASE)/../port/stdio/%.c
 	$(COMPILE.c) -o $@ $<
--- old/usr/src/lib/libc/amd64/Makefile	Sun Aug  5 23:40:58 2018
+++ new/usr/src/lib/libc/amd64/Makefile	Sun Aug  5 23:40:58 2018
@@ -622,6 +622,11 @@
 	vwprintf.o		\
 	wprintf.o
 
+PORTSOCKET=			\
+	sockatmark.o		\
+	socket.o		\
+	socketpair.o
+
 # Preserved solely to ease maintenance of 32-bit and 64-bit library builds
 # This macro should ALWAYS be empty; native APIs are already 'large file'.
 PORTSTDIO64=
@@ -975,6 +980,7 @@
 	$(PORTPRINT)		\
 	$(PORTPRINT_W)		\
 	$(PORTREGEX)		\
+	$(PORTSOCKET)		\
 	$(PORTSTDIO)		\
 	$(PORTSTDIO64)		\
 	$(PORTSTDIO_W)		\
@@ -1108,6 +1114,7 @@
 	$(PORTLOCALE:%.o=$(LIBCDIR)/port/locale/%.c)	\
 	$(PORTPRINT:%.o=$(LIBCDIR)/port/print/%.c)	\
 	$(PORTREGEX:%.o=$(LIBCDIR)/port/regex/%.c)	\
+	$(PORTSOCKET:%.o=$(LIBCDIR)/port/socket/%.c)	\
 	$(PORTSTDIO:%.o=$(LIBCDIR)/port/stdio/%.c)	\
 	$(PORTSYS:%.o=$(LIBCDIR)/port/sys/%.c)		\
 	$(AIOOBJS:%.o=$(LIBCDIR)/port/aio/%.c)		\
--- old/usr/src/lib/libc/common/sys/_so_accept.s	Sun Aug  5 23:40:58 2018
+++ new/usr/src/lib/libc/common/sys/_so_accept.s	Sun Aug  5 23:40:58 2018
@@ -31,10 +31,10 @@
 
 	.file	"_so_accept.s"
 
-/* C library -- __so_accept						*/
 /*
- * int __so_accept(int sock, struct sockaddr *addr, int *addrlen, int vers,
- *     int flags)
+ * C library -- __so_accept
+ *
+ * int __so_accept(int, struct sockaddr *, socklen_t *, int, int)
  */
 
 #include "SYS.h"
--- old/usr/src/lib/libc/common/sys/_so_bind.s	Sun Aug  5 23:40:58 2018
+++ new/usr/src/lib/libc/common/sys/_so_bind.s	Sun Aug  5 23:40:58 2018
@@ -18,10 +18,10 @@
  *
  * CDDL HEADER END
  */
+
 /*	Copyright (c) 1988 AT&T	*/
 /*	  All Rights Reserved	*/
 
-
 /*
  * Copyright 2004 Sun Microsystems, Inc.  All rights reserved.
  * Use is subject to license terms.
@@ -29,8 +29,11 @@
 
 	.file	"_so_bind.s"
 
-/* C library -- _so_bind						*/
-/* int _so_bind (int fildes, struct sockaddr *name, int namelen, int vers); */
+/*
+ * C library -- _so_bind
+ *
+ * int _so_bind(int, const struct sockaddr *, socklen_t, int);
+ */
 
 #include "SYS.h"
 
--- old/usr/src/lib/libc/common/sys/_so_connect.s	Sun Aug  5 23:40:58 2018
+++ new/usr/src/lib/libc/common/sys/_so_connect.s	Sun Aug  5 23:40:58 2018
@@ -29,8 +29,11 @@
 
 	.file	"_so_connect.s"
 
-/* C library -- __so_connect						*/
-/* int __so_connect(int sock, struct sockaddr *addr, int addrlen, int vers) */
+/*
+ * C library -- __so_connect
+ *
+ * int __so_connect(int, const struct sockaddr *, socklen_t, int)
+ */
 
 #include "SYS.h"
 
--- old/usr/src/lib/libc/common/sys/_so_getpeername.s	Sun Aug  5 23:40:59 2018
+++ new/usr/src/lib/libc/common/sys/_so_getpeername.s	Sun Aug  5 23:40:59 2018
@@ -18,10 +18,10 @@
  *
  * CDDL HEADER END
  */
+
 /*	Copyright (c) 1988 AT&T	*/
 /*	  All Rights Reserved	*/
 
-
 /*
  * Copyright 2004 Sun Microsystems, Inc.  All rights reserved.
  * Use is subject to license terms.
@@ -29,9 +29,11 @@
 
 	.file	"_so_getpeername.s"
 
-/* C library -- _so_getpeername					*/
-/* int _so_getpeername (int fildes, struct sockaddr *name,	*/
-/*			int namelen, int vers);			*/
+/*
+ * C library -- _so_getpeername
+ *
+ * int _so_getpeername(int, struct sockaddr *, socklen_t *, int);
+ */
 
 #include "SYS.h"
 
--- old/usr/src/lib/libc/common/sys/_so_getsockname.s	Sun Aug  5 23:40:59 2018
+++ new/usr/src/lib/libc/common/sys/_so_getsockname.s	Sun Aug  5 23:40:59 2018
@@ -18,10 +18,10 @@
  *
  * CDDL HEADER END
  */
+
 /*	Copyright (c) 1988 AT&T	*/
 /*	  All Rights Reserved	*/
 
-
 /*
  * Copyright 2004 Sun Microsystems, Inc.  All rights reserved.
  * Use is subject to license terms.
@@ -29,9 +29,11 @@
 
 	.file	"_so_getsockname.s"
 
-/* C library -- _so_getsockname						*/
-/* int _so_getsockname (int fildes, struct sockaddr *name, int namelen,	*/
-/*			int vers);					*/
+/*
+ * C library -- _so_getsockname
+ *
+ * int _so_getsockname(int, struct sockaddr *, socklen_t *, int);
+ */
 
 #include "SYS.h"
 
--- old/usr/src/lib/libc/common/sys/_so_getsockopt.s	Sun Aug  5 23:40:59 2018
+++ new/usr/src/lib/libc/common/sys/_so_getsockopt.s	Sun Aug  5 23:40:59 2018
@@ -18,10 +18,10 @@
  *
  * CDDL HEADER END
  */
+
 /*	Copyright (c) 1988 AT&T	*/
 /*	  All Rights Reserved	*/
 
-
 /*
  * Copyright 2004 Sun Microsystems, Inc.  All rights reserved.
  * Use is subject to license terms.
@@ -29,9 +29,11 @@
 
 	.file	"_so_getsockopt.s"
 
-/* C library -- _so_getsockopt					*/
-/* int _so_getsockopt (int socket, int level, int option_name,	*/
-/*	 void *option_value, size_t *option_len, int vers);	*/
+/*
+ * C library -- _so_getsockopt
+ *
+ * int _so_getsockopt(int, int, int, void *, socklen_t *, int);
+ */
 
 #include "SYS.h"
 
--- old/usr/src/lib/libc/common/sys/_so_listen.s	Sun Aug  5 23:40:59 2018
+++ new/usr/src/lib/libc/common/sys/_so_listen.s	Sun Aug  5 23:40:59 2018
@@ -18,10 +18,10 @@
  *
  * CDDL HEADER END
  */
+
 /*	Copyright (c) 1988 AT&T	*/
 /*	  All Rights Reserved	*/
 
-
 /*
  * Copyright 2004 Sun Microsystems, Inc.  All rights reserved.
  * Use is subject to license terms.
@@ -29,8 +29,11 @@
 
 	.file	"_so_listen.s"
 
-/* C library -- _so_listen					*/
-/* int _so_listen (int socket, int backlog, int vers);	 	*/
+/*
+ * C library -- _so_listen
+ *
+ * int _so_listen(int, int, int);
+ */
 
 #include "SYS.h"
 
--- old/usr/src/lib/libc/common/sys/_so_recv.s	Sun Aug  5 23:41:00 2018
+++ new/usr/src/lib/libc/common/sys/_so_recv.s	Sun Aug  5 23:41:00 2018
@@ -29,8 +29,11 @@
 
 	.file	"_so_recv.s"
 
-/* C library -- _so_recv						*/
-/* int __so_recv(int sock, void *buffer, size_t len, int flags)		*/
+/*
+ * C library -- __so_recv
+ *
+ * ssize_t __so_recv(int, void *, size_t, int)
+ */
 
 #include "SYS.h"
 
--- old/usr/src/lib/libc/common/sys/_so_recvfrom.s	Sun Aug  5 23:41:00 2018
+++ new/usr/src/lib/libc/common/sys/_so_recvfrom.s	Sun Aug  5 23:41:00 2018
@@ -29,10 +29,11 @@
 
 	.file	"_so_recvfrom.s"
 
-/* C library -- __so_recvfrom					*/
 /*
- * int __so_recvfrom(int sock, void *buffer, size_t len, int flags,
- *		 struct sockaddr *addr, size_t *addrlen)
+ * C library -- __so_recvfrom
+ *
+ * ssize_t __so_recvfrom(int, void *, size_t, int, struct sockaddr *,
+ *     socklen_t *)
  */
 
 #include "SYS.h"
--- old/usr/src/lib/libc/common/sys/_so_recvmsg.s	Sun Aug  5 23:41:00 2018
+++ new/usr/src/lib/libc/common/sys/_so_recvmsg.s	Sun Aug  5 23:41:00 2018
@@ -29,8 +29,11 @@
 
 	.file	"_so_recvmsg.s"
 
-/* C library -- __so_recvmsg					*/
-/* int __so_recvmsg(int sock, struct msghdr *msg, int flags)	*/
+/*
+ * C library -- __so_recvmsg
+ *
+ * ssize_t __so_recvmsg(int, struct msghdr *, int)
+ */
 
 #include "SYS.h"
 
--- old/usr/src/lib/libc/common/sys/_so_send.s	Sun Aug  5 23:41:01 2018
+++ new/usr/src/lib/libc/common/sys/_so_send.s	Sun Aug  5 23:41:01 2018
@@ -29,8 +29,11 @@
 
 	.file	"_so_send.s"
 
-/* C library -- __so_send						*/
-/* int __so_send(int socket, const void *buffer, size_t len, int flags)	*/
+/*
+ * C library -- __so_send
+ *
+ * ssize_t __so_send(int, const void *, size_t, int)
+ */
 
 #include "SYS.h"
 
--- old/usr/src/lib/libc/common/sys/_so_sendmsg.s	Sun Aug  5 23:41:01 2018
+++ new/usr/src/lib/libc/common/sys/_so_sendmsg.s	Sun Aug  5 23:41:01 2018
@@ -29,8 +29,11 @@
 
 	.file	"_so_sendmsg.s"
 
-/* C library -- __so_sendmsg						*/
-/* int __so_sendmsg(int sock, const struct msghdr *msg, int flags)	*/
+/*
+ * C library -- __so_sendmsg
+ *
+ * ssize_t __so_sendmsg(int, const struct msghdr *, int)
+ */
 
 #include "SYS.h"
 
--- old/usr/src/lib/libc/common/sys/_so_sendto.s	Sun Aug  5 23:41:01 2018
+++ new/usr/src/lib/libc/common/sys/_so_sendto.s	Sun Aug  5 23:41:01 2018
@@ -29,10 +29,11 @@
 
 	.file	"_so_sendto.s"
 
-/* C library -- __so_sendto					*/
 /*
- * int __so_sendto(int sock, const void *buffer, size_t len, int flags,
- *		 const struct sockaddr *addr, int addrlen);
+ * C library -- __so_sendto
+ *
+ * ssize_t __so_sendto(int, const void *, size_t, int, const struct sockaddr *,
+ *     socklen_t);
  */
 
 #include "SYS.h"
--- old/usr/src/lib/libc/common/sys/_so_setsockopt.s	Sun Aug  5 23:41:01 2018
+++ new/usr/src/lib/libc/common/sys/_so_setsockopt.s	Sun Aug  5 23:41:01 2018
@@ -29,9 +29,11 @@
 
 	.file	"_so_setsockopt.s"
 
-/* C library -- _so_setsockopt					*/
-/* int _so_setsockopt (int socket, int level, int option_name,	*/
-/*	 void *option_value, size_t option_len, int vers);	*/
+/*
+ * C library -- _so_setsockopt
+ *
+ * int _so_setsockopt(int, int, int, const void *, socklen_t, int);
+ */
 
 #include "SYS.h"
 
--- old/usr/src/lib/libc/common/sys/_so_shutdown.s	Sun Aug  5 23:41:02 2018
+++ new/usr/src/lib/libc/common/sys/_so_shutdown.s	Sun Aug  5 23:41:02 2018
@@ -29,8 +29,11 @@
 
 	.file	"_so_shutdown.s"
 
-/* C library -- _so_shutdown					*/
-/* int _so_shutdown (int fildes, int how, int vers);		*/
+/*
+ * C library -- _so_shutdown
+ *
+ * int _so_shutdown (int, int, int);
+ */
 
 #include "SYS.h"
 
--- old/usr/src/lib/libc/common/sys/_so_socket.s	Sun Aug  5 23:41:02 2018
+++ new/usr/src/lib/libc/common/sys/_so_socket.s	Sun Aug  5 23:41:02 2018
@@ -29,10 +29,10 @@
 
 	.file	"_so_socket.s"
 
-/* C library -- _so_socket					*/
 /*
- * int _so_socket (int domain, int type, int protocol,
- *			dev_t dev, int version);
+ * C library -- _so_socket
+ *
+ * int _so_socket(int, int, int, dev_t, int);
  */
 
 #include "SYS.h"
--- old/usr/src/lib/libc/common/sys/_so_socketpair.s	Sun Aug  5 23:41:02 2018
+++ new/usr/src/lib/libc/common/sys/_so_socketpair.s	Sun Aug  5 23:41:02 2018
@@ -18,10 +18,10 @@
  *
  * CDDL HEADER END
  */
+
 /*	Copyright (c) 1988 AT&T	*/
 /*	  All Rights Reserved	*/
 
-
 /*
  * Copyright 2004 Sun Microsystems, Inc.  All rights reserved.
  * Use is subject to license terms.
@@ -29,9 +29,10 @@
 
 	.file	"_so_socketpair.s"
 
-/* C library -- _so_socketpair					*/
 /*
- * int _so_socketpair (int sv[2]);
+ * C library -- _so_socketpair
+ *
+ * int _so_socketpair(int *);
  */
 
 #include "SYS.h"
--- old/usr/src/lib/libc/i386/Makefile.com	Sun Aug  5 23:41:02 2018
+++ new/usr/src/lib/libc/i386/Makefile.com	Sun Aug  5 23:41:02 2018
@@ -662,6 +662,11 @@
 	vsprintf_c89.o		\
 	vwprintf_c89.o
 
+PORTSOCKET=			\
+	sockatmark.o		\
+	socket.o		\
+	socketpair.o
+
 PORTSTDIO_C89=			\
 	vscanf_c89.o		\
 	vwscanf_c89.o		\
@@ -1016,6 +1021,7 @@
 	$(PORTPRINT_W)		\
 	$(PORTREGEX)		\
 	$(PORTREGEX64)		\
+	$(PORTSOCKET)		\
 	$(PORTSTDIO)		\
 	$(PORTSTDIO64)		\
 	$(PORTSTDIO_C89)	\
@@ -1171,6 +1177,7 @@
 	$(PORTLOCALE:%.o=$(LIBCDIR)/port/locale/%.c)	\
 	$(PORTPRINT:%.o=$(LIBCDIR)/port/print/%.c)	\
 	$(PORTREGEX:%.o=$(LIBCDIR)/port/regex/%.c)	\
+	$(PORTSOCKET:%.o=$(LIBCDIR)/port/socket/%.c)	\
 	$(PORTSTDIO:%.o=$(LIBCDIR)/port/stdio/%.c)	\
 	$(PORTSYS:%.o=$(LIBCDIR)/port/sys/%.c)		\
 	$(AIOOBJS:%.o=$(LIBCDIR)/port/aio/%.c)		\
--- old/usr/src/lib/libc/inc/libc.h	Sun Aug  5 23:41:03 2018
+++ new/usr/src/lib/libc/inc/libc.h	Sun Aug  5 23:41:03 2018
@@ -200,16 +200,6 @@
 extern greg_t _getsp(void);
 
 /*
- * defined in _so_setsockopt.s
- */
-extern int _so_setsockopt(int, int, int, const char *, int);
-
-/*
- * defined in _so_getsockopt.s
- */
-extern int _so_getsockopt(int, int, int, char *, int *);
-
-/*
  * defined in lsign.s
  */
 extern int lsign(dl_t);
--- old/usr/src/lib/libc/port/mapfile-vers	Sun Aug  5 23:41:03 2018
+++ new/usr/src/lib/libc/port/mapfile-vers	Sun Aug  5 23:41:03 2018
@@ -77,6 +77,29 @@
 $add amd64
 $endif
 
+SYMBOL_VERSION ILLUMOS_0.26 {	# socket moved from libsocket
+    protected:
+	accept4;
+	accept;
+	bind;
+	connect;
+	getpeername;
+	getsockname;
+	getsockopt;
+	listen;
+	recv;
+	recvfrom;
+	recvmsg;
+	send;
+	sendmsg;
+	sendto;
+	setsockopt;
+	sockatmark;
+	socketpair;
+	shutdown;
+	socket;
+} ILLUMOS_0.25;
+
 SYMBOL_VERSION ILLUMOS_0.25 {	# inet_* moved from libnsl/libsocket
     protected:
 	inet_addr;
@@ -2909,10 +2932,12 @@
 $endif
 
     protected:
+	_accept;
+	_accept4;
 	acctctl;
 	allocids;
-	_assert_c99;
 	__assert_c99;
+	_assert_c99;
 	_assfail;
 	attr_count;
 	attr_to_data_type;
@@ -2920,9 +2945,11 @@
 	attr_to_option;
 	attr_to_xattr_view;
 	_autofssys;
+	_bind;
 	_bufsync;
 	_cladm;
 	__class_quadruple;
+	_connect;
 	core_get_default_content;
 	core_get_default_path;
 	core_get_global_content;
@@ -2989,7 +3016,10 @@
 	_getfp;
 	_getgroupsbymember;
 	_getlogin_r;
+	_getpeername;
 	getrandom;
+	_getsockname;
+	_getsockopt;
 	_getsp;
 	__gettsp;
 	getvmusage;
@@ -3014,6 +3044,7 @@
 	klpd_unregister_id;
 	_lgrp_home_fast		{ FLAGS = NODYNSORT };
 	_lgrpsys;
+	_listen;
 	_lltostr;
 	_lock_clear;
 	_lock_try;
@@ -3065,6 +3096,9 @@
 	__priv_bracket;
 	__priv_relinquish;
 	psecflags;
+	psecflags_default;
+	psecflags_validate;
+	psecflags_validate_delta;
 	pset_assign_forced;
 	pset_bind_lwp;
 	_psignal;
@@ -3076,6 +3110,9 @@
 	rctlctl;
 	rctllist;
 	_realbufend;
+	_recv;
+	_recvfrom;
+	_recvmsg;
 	_resume;
 	_resume_ret;
 	_rpcsys;
@@ -3083,35 +3120,37 @@
 	scrwidth;
 	secflag_by_name;
 	secflag_clear;
+	secflag_isset;
 	secflags_copy;
 	secflags_difference;
+	secflag_set;
 	secflags_fullset;
 	secflags_intersection;
 	secflags_isempty;
-	secflag_isset;
 	secflags_issubset;
 	secflags_issuperset;
-	secflag_set;
-	secflag_to_bit;
-	secflag_to_str;
-	secflags_union;
-	psecflags_validate_delta;
-	secflags_zero;
-	psecflags_default;
 	secflags_parse;
 	secflags_to_str;
-	psecflags_validate;
-	semctl64;
+	secflags_union;
+	secflags_zero;
+	secflag_to_bit;
+	secflag_to_str;
 	_semctl64;
-	set_setcontext_enforcement;
+	semctl64;
+	_send;
+	_sendmsg;
+	_sendto;
 	_setbufend;
 	__set_errno;
 	setprojrctl;
 	_setregid;
 	_setreuid;
+	set_setcontext_enforcement;
 	setsigacthandler;
-	shmctl64;
+	_setsockopt;
 	_shmctl64;
+	shmctl64;
+	_shutdown;
 	sigflag;
 	_signal;
 	_sigoff;
@@ -3119,6 +3158,10 @@
 	_so_accept;
 	_so_bind;
 	_sockconfig;
+	_socket;
+	_socket_bsd;
+	_socketpair;
+	_socketpair_bsd;
 	_so_connect;
 	_so_getpeername;
 	_so_getsockname;
@@ -3142,51 +3185,51 @@
 	syscall;
 	_sysconfig;
 	__systemcall;
-	thr_continue_allmutators;
 	_thr_continue_allmutators;
-	thr_continue_mutator;
+	thr_continue_allmutators;
 	_thr_continue_mutator;
-	thr_getstate;
+	thr_continue_mutator;
 	_thr_getstate;
-	thr_mutators_barrier;
+	thr_getstate;
 	_thr_mutators_barrier;
+	thr_mutators_barrier;
 	thr_probe_setup;
 	_thr_schedctl;
-	thr_setmutator;
 	_thr_setmutator;
-	thr_setstate;
+	thr_setmutator;
 	_thr_setstate;
-	thr_sighndlrinfo;
+	thr_setstate;
 	_thr_sighndlrinfo;
+	thr_sighndlrinfo;
 	_thr_slot_offset;
-	thr_suspend_allmutators;
 	_thr_suspend_allmutators;
-	thr_suspend_mutator;
+	thr_suspend_allmutators;
 	_thr_suspend_mutator;
-	thr_wait_mutator;
+	thr_suspend_mutator;
 	_thr_wait_mutator;
+	thr_wait_mutator;
 	__tls_get_addr;
 	_tmem_get_base;
 	_tmem_get_nentries;
 	_tmem_set_cleanup;
 	tpool_create;
-	tpool_dispatch;
 	tpool_destroy;
-	tpool_wait;
+	tpool_dispatch;
+	tpool_member;
+	tpool_resume;
 	tpool_suspend;
 	tpool_suspended;
-	tpool_resume;
-	tpool_member;
+	tpool_wait;
 	_ttyname_dev;
 	_ucred_alloc;
-	ucred_getamask;
 	_ucred_getamask;
-	ucred_getasid;
+	ucred_getamask;
 	_ucred_getasid;
-	ucred_getatid;
+	ucred_getasid;
 	_ucred_getatid;
-	ucred_getauid;
+	ucred_getatid;
 	_ucred_getauid;
+	ucred_getauid;
 	_ulltostr;
 	_uncached_getgrgid_r;
 	_uncached_getgrnam_r;
@@ -3209,6 +3252,15 @@
 	_wrtchk;
 	_xflsbuf;
 	_xgetwidth;
+	__xnet_bind;
+	__xnet_connect;
+	__xnet_getsockopt;
+	__xnet_listen;
+	__xnet_recvmsg;
+	__xnet_sendmsg;
+	__xnet_sendto;
+	__xnet_socket;
+	__xnet_socketpair;
 	zone_add_datalink;
 	zone_boot;
 	zone_check_datalink;
--- /dev/null	Sun Aug  5 23:40:50 2018
+++ new/usr/src/lib/libc/port/socket/sockatmark.c	Sun Aug  5 23:41:03 2018
@@ -0,0 +1,44 @@
+/*
+ * CDDL HEADER START
+ *
+ * The contents of this file are subject to the terms of the
+ * Common Development and Distribution License, Version 1.0 only
+ * (the "License").  You may not use this file except in compliance
+ * with the License.
+ *
+ * You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
+ * or http://www.opensolaris.org/os/licensing.
+ * See the License for the specific language governing permissions
+ * and limitations under the License.
+ *
+ * When distributing Covered Code, include this CDDL HEADER in each
+ * file and include the License file at usr/src/OPENSOLARIS.LICENSE.
+ * If applicable, add the following below this CDDL HEADER, with the
+ * fields enclosed by brackets "[]" replaced with your own identifying
+ * information: Portions Copyright [yyyy] [name of copyright owner]
+ *
+ * CDDL HEADER END
+ */
+/*
+ * Copyright 2003 Sun Microsystems, Inc.  All rights reserved.
+ * Use is subject to license terms.
+ */
+
+#include <sys/sockio.h>
+#include <unistd.h>
+
+#pragma weak sockatmark = _sockatmark
+
+/*
+ * Determine whether the socket is at the out-of-band
+ * data mark.
+ */
+int
+_sockatmark(int sock)
+{
+	int val;
+
+	if (ioctl(sock, SIOCATMARK, &val) == -1)
+		return (-1);
+	return (val);
+}
--- /dev/null	Sun Aug  5 23:41:04 2018
+++ new/usr/src/lib/libc/port/socket/socket.c	Sun Aug  5 23:41:04 2018
@@ -0,0 +1,303 @@
+/*
+ * CDDL HEADER START
+ *
+ * The contents of this file are subject to the terms of the
+ * Common Development and Distribution License (the "License").
+ * You may not use this file except in compliance with the License.
+ *
+ * You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
+ * or http://www.opensolaris.org/os/licensing.
+ * See the License for the specific language governing permissions
+ * and limitations under the License.
+ *
+ * When distributing Covered Code, include this CDDL HEADER in each
+ * file and include the License file at usr/src/OPENSOLARIS.LICENSE.
+ * If applicable, add the following below this CDDL HEADER, with the
+ * fields enclosed by brackets "[]" replaced with your own identifying
+ * information: Portions Copyright [yyyy] [name of copyright owner]
+ *
+ * CDDL HEADER END
+ */
+
+/*
+ * Copyright 2008 Sun Microsystems, Inc.  All rights reserved.
+ * Use is subject to license terms.
+ */
+
+/*
+ * Copyright (c) 2013, OmniTI Computer Consulting, Inc. All rights reserved.
+ * Copyright 2018 Nexenta Systems, Inc.
+ */
+
+#include "lint.h"
+
+#include <sys/types.h>
+#include <sys/socket.h>
+#include <sys/stropts.h>
+#include <sys/stream.h>
+#include <sys/socketvar.h>
+#include <sys/sockio.h>
+
+#include <errno.h>
+#include <stdlib.h>
+#include <unistd.h>
+#include <stropts.h>
+#include <stdio.h>
+#include <strings.h>
+#include <netinet/sctp.h>
+
+#pragma weak accept = _accept
+#pragma weak accept4 = _accept4
+#pragma weak bind = _bind
+#pragma weak connect = _connect
+#pragma weak getpeername = _getpeername
+#pragma weak getsockname = _getsockname
+#pragma weak getsockopt = _getsockopt
+#pragma weak listen = _listen
+#pragma weak recv = _recv
+#pragma weak recvfrom = _recvfrom
+#pragma weak recvmsg = _recvmsg
+#pragma weak send = _send
+#pragma weak sendmsg = _sendmsg
+#pragma weak sendto = _sendto
+#pragma weak setsockopt = _setsockopt
+#pragma weak shutdown = _shutdown
+#pragma weak socket = _socket
+
+extern int _so_accept(int, struct sockaddr *, socklen_t *, int, int);
+extern int _so_bind(int, const struct sockaddr *, socklen_t, int);
+extern int _so_connect(int, const struct sockaddr *, socklen_t, int);
+extern int _so_getpeername(int, struct sockaddr *, socklen_t *,
+    int);
+extern int _so_getsockname(int, struct sockaddr *, socklen_t *,
+    int);
+extern int _so_getsockopt(int, int, int, void *, socklen_t *, int);
+extern int _so_listen(int, int, int);
+extern ssize_t _so_recv(int, void *, size_t, int);
+extern ssize_t _so_recvfrom(int, void *, size_t, int, struct sockaddr *,
+    socklen_t *);
+extern ssize_t _so_recvmsg(int, struct msghdr *, int);
+extern ssize_t _so_send(int, const void *, size_t, int);
+extern ssize_t _so_sendmsg(int, const struct msghdr *, int);
+extern ssize_t _so_sendto(int, const void *, size_t, int,
+    const struct sockaddr *, socklen_t);
+extern int _so_setsockopt(int, int, int, const void *, socklen_t, int);
+extern int _so_shutdown(int, int, int);
+extern int _so_socket(int, int, int, dev_t, int);
+
+int
+_accept(int sock, struct sockaddr *_RESTRICT_KYWD addr, socklen_t *addrlen)
+{
+	return (_so_accept(sock, addr, addrlen, SOV_DEFAULT, 0));
+}
+
+int
+_accept4(int sock, struct sockaddr *_RESTRICT_KYWD addr, socklen_t *addrlen,
+    int flags)
+{
+	return (_so_accept(sock, addr, addrlen, SOV_DEFAULT, flags));
+}
+
+/*
+ * Note that regular sockets use SOV_SOCKBSD here to not allow a rebind of an
+ * already bound socket.
+ */
+int
+_bind(int sock, const struct sockaddr *addr, socklen_t addrlen)
+{
+	return (_so_bind(sock, addr, addrlen, SOV_SOCKBSD));
+}
+
+int
+_connect(int sock, const struct sockaddr *addr, socklen_t addrlen)
+{
+	return (_so_connect(sock, addr, addrlen, SOV_DEFAULT));
+}
+
+int
+_getpeername(int sock, struct sockaddr *_RESTRICT_KYWD name, socklen_t *namelen)
+{
+	return (_so_getpeername(sock, name, namelen, SOV_DEFAULT));
+}
+
+int
+_getsockname(int sock, struct sockaddr *_RESTRICT_KYWD name, socklen_t *namelen)
+{
+	return (_so_getsockname(sock, name, namelen, SOV_DEFAULT));
+}
+
+int
+_getsockopt(int sock, int level, int optname, void *_RESTRICT_KYWD optval,
+    socklen_t *optlen)
+{
+	if (level == IPPROTO_SCTP) {
+		sctp_assoc_t id = 0;
+		socklen_t len = *optlen;
+		int err = 0;
+		struct sctpopt sopt;
+
+		switch (optname) {
+		case SCTP_RTOINFO:
+		case SCTP_ASSOCINFO:
+		case SCTP_SET_PEER_PRIMARY_ADDR:
+		case SCTP_PRIMARY_ADDR:
+		case SCTP_PEER_ADDR_PARAMS:
+		case SCTP_STATUS:
+		case SCTP_GET_PEER_ADDR_INFO:
+			/*
+			 * Association ID is the first element params struct
+			 */
+			bcopy(optval, &id, sizeof (id));
+			break;
+		case SCTP_DEFAULT_SEND_PARAM:
+			bcopy(&((struct sctp_sndrcvinfo *)
+			    optval)->sinfo_assoc_id, &id, sizeof (id));
+			break;
+		}
+
+		sopt.sopt_aid = id;
+		sopt.sopt_name = optname;
+		sopt.sopt_val = optval;
+		sopt.sopt_len = len;
+		if (ioctl(sock, SIOCSCTPGOPT, &sopt) == -1) {
+			err = -1;
+		} else {
+			*optlen = sopt.sopt_len;
+		}
+		return (err);
+	} else {
+		return (_so_getsockopt(sock, level, optname, optval, optlen,
+		    SOV_DEFAULT));
+	}
+}
+
+int
+_listen(int sock, int backlog)
+{
+	return (_so_listen(sock, backlog, SOV_DEFAULT));
+}
+
+ssize_t
+_recv(int sock, void *buf, size_t len, int flags)
+{
+	return (_so_recv(sock, buf, len, flags & ~MSG_XPG4_2));
+}
+
+int
+_recvfrom(int sock, void *_RESTRICT_KYWD buf, size_t len, int flags,
+    struct sockaddr *_RESTRICT_KYWD addr, socklen_t *addrlen)
+{
+	return (_so_recvfrom(sock, buf, len, flags & ~MSG_XPG4_2,
+	    addr, addrlen));
+}
+
+ssize_t
+_recvmsg(int sock, struct msghdr *msg, int flags)
+{
+	return (_so_recvmsg(sock, msg, flags & ~MSG_XPG4_2));
+}
+
+ssize_t
+_send(int sock, const void *buf, size_t len, int flags)
+{
+	return (_so_send(sock, buf, len, flags & ~MSG_XPG4_2));
+}
+
+ssize_t
+_sendmsg(int sock, const struct msghdr *msg, int flags)
+{
+	return (_so_sendmsg(sock, msg, flags & ~MSG_XPG4_2));
+}
+
+ssize_t
+_sendto(int sock, const void *buf, size_t len, int flags,
+    const struct sockaddr *addr, socklen_t addrlen)
+{
+	return (_so_sendto(sock, buf, len, flags & ~MSG_XPG4_2, addr, addrlen));
+}
+
+int
+_setsockopt(int sock, int level, int optname, const void *optval,
+    socklen_t optlen)
+{
+	return (_so_setsockopt(sock, level, optname, optval, optlen,
+	    SOV_DEFAULT));
+}
+
+int
+_shutdown(int sock, int how)
+{
+	return (_so_shutdown(sock, how, SOV_DEFAULT));
+}
+
+int
+_socket(int family, int type, int protocol)
+{
+	return (_so_socket(family, type, protocol, NULL, SOV_DEFAULT));
+}
+
+/*
+ * Used by the BCP library.
+ */
+int
+_socket_bsd(int family, int type, int protocol)
+{
+	return (_so_socket(family, type, protocol, NULL, SOV_SOCKBSD));
+}
+
+
+int
+__xnet_bind(int sock, const struct sockaddr *addr, socklen_t addrlen)
+{
+	return (_so_bind(sock, addr, addrlen, SOV_XPG4_2));
+}
+
+int
+__xnet_connect(int sock, const struct sockaddr *addr, socklen_t addrlen)
+{
+	return (_so_connect(sock, addr, addrlen, SOV_XPG4_2));
+}
+
+int
+__xnet_getsockopt(int sock, int level, int optname, void *optval,
+    socklen_t *optlen)
+{
+	if (level == IPPROTO_SCTP) {
+		return (_getsockopt(sock, level, optname, optval, optlen));
+	} else {
+		return (_so_getsockopt(sock, level, optname, optval, optlen,
+		    SOV_XPG4_2));
+	}
+}
+
+int
+__xnet_listen(int sock, int backlog)
+{
+	return (_so_listen(sock, backlog, SOV_XPG4_2));
+}
+
+int
+__xnet_recvmsg(int sock, struct msghdr *msg, int flags)
+{
+	return (_so_recvmsg(sock, msg, flags | MSG_XPG4_2));
+}
+
+int
+__xnet_sendmsg(int sock, const struct msghdr *msg, int flags)
+{
+	return (_so_sendmsg(sock, msg, flags | MSG_XPG4_2));
+}
+
+int
+__xnet_sendto(int sock, const void *buf, size_t len, int flags,
+	const struct sockaddr *addr, socklen_t addrlen)
+{
+	return (_so_sendto(sock, buf, len, flags | MSG_XPG4_2,
+	    addr, addrlen));
+}
+
+int
+__xnet_socket(int family, int type, int protocol)
+{
+	return (_so_socket(family, type, protocol, NULL, SOV_XPG4_2));
+}
